/**************************** program_TRF69 **********************************************************
; purpose:
;	   programs a word to A, B, C or D word register of the TRF6901 
;	   gets the settings from the calling routine in R6 and R7
; 
;*******************************************************************************************************/
#include  <msp430x44x.h>
#include  "std_f43x.asm"									  
#define Count1		R8
#define Count2		R9
#define   counter	R10			  ; universal counter

	.GLOBAL	_program_TRF69
;	.EXTERNAL	CL430_1_23_L08
	.pseg	TRF6901


_program_TRF69

init_high_byte
		  DINT										
                  PUSH    R10
                  PUSH    R9
                  PUSH    R8
                  PUSH    R7
                  PUSH    R6
                  PUSH    R5
                  PUSH    R4
                  MOV     R12,word_h                  ;mov data to appropriate register
                  MOV     R13,word_l    ;mgs modif!!!!!
		  BIC.B	  #strobe,&P4OUT							; reset Strobe port
		  BIS.B	  #strobe,&P4DIR							; switch Strobe to output direction
		  MOV	  #02h,counter								; initialize the counter for high and low byte
		  MOV	  #08h,bits_r								; initialize bitcounter
;		  MOV	  word_h,word_trf	
		  MOV	  R6,R4			 
		  SWPB	  word_trf									; push the low byte to the high byte, only the 
															; data in the low byte is relevant
		  JMP	  program_word

init_low_byte
		  MOV	  #010h,bits_r								; initialize bitcounter
;		  MOV	  word_l,word_trf							; push the low byte to the programming buffer
		  MOV	  R7,R4			 

program_word
		  RLC	  word_trf									; push the msb of the programming buffer to carry
		  JNC	  program_low

program_high
		  BIS.B	  #data,&P4OUT								; set data(P1.7)
				   
program_clock
		  BIS.B	  #clk,&P3OUT								; generate a pulse on the clock line
		  BIC.B	  #clk,&P3OUT							 
  
program_next_bit
		  DEC	  bits_r									; decrement bit counter
		  JNZ	  program_word								; have already all bits been sent?
		  DEC	  counter									; decrement counter for low byte recognition
		  JNZ	  init_low_byte								; low byte is to be programmed

generate_strobe
		  BIC.B	  #data,&P4OUT								; reset data
		  BIS.B	  #strobe,&P4OUT							; set strobe(P1.5)
		  BIC.B	  #strobe,&P4OUT							; clear strobe(P1.5)
		  BIC.B	  #strobe,&P4DIR							; set strobe(P1.5) to input direction
                  POP     R4
                  POP     R5
                  POP     R6
                  POP     R7
                  POP     R8
                  POP     R9
                  POP     R10
 
		  EINT												
		  RET												; back to calling routine

program_low
		  BIC.B	  #data,&P4OUT								; clear data(P1.7)
		  JMP	  program_clock

end_program_TRF69
                  END